// -------------------------------------- Opes (minusculas) ------------------------

#define system_type					vertical
#define system_version				700
#define laser_type 					none
#define software_type				osx64
#define tag_type 					S002

// ----------------------------------------------------------------------------------

#define	compile_crash_game				0
#define	compile_sprites				0
#define	compile_malloc					1
#define	compile_scroll					0
#define	compile_com2_block				0
#define	compile_radio_message			0
#define	compile_com_message				1

#define	debug						0

#include "stdlib.c"

char program_name[17]="OS64 0.001      ";

main()
{
	int stackpt1,stackpt2;
	char *buffer;
	int size;
	dont_halt_on_error_func_malloc=1;
	size=129*1024;
	do
	{
		size-=1024;
		buffer=malloc(size);
	}
	while(!buffer);
	memset(buffer,0,size);
	print_number(size);
	print_string(" bytes free at");
	new_line();
	print_number(buffer);
	new_line();
	print_string("Loading...");
	new_line();
	beep(100,100);
	enable_com_port_disable_timer();
	push_variable(load_program_from_rs232(buffer,-1));
	disable_com_port_enable_timer();
	if(pop_variable())
	{
		cls();
		stackpt1=read_cpu_register32(CPU_STACK)+8;
		buffer();
		set_update_screen(1);
		stackpt2=read_cpu_register32(CPU_STACK)+8;

		if(stackpt1!=stackpt2)
		{
			set_display(0);
			cls();
			print_string("Erro Stack");
			new_line();
			print_number(stackpt1);
			new_line();
			print_number(stackpt2);
			getch();

		}
		
	}
	free(buffer);
}

load_program_from_rs232(char *buffer,int timeout)
{
	char c;
	char *address;
	char *counter;
	int checksum;
	do
	{
		write_cpu_register32(CPU_COM2TIMEOUT,timeout);
		do
		{
			restart_checksum();
			if(read_com2_bytes(&c,1)<0) { return(0); }
		}
		while(c!='S');
		write_cpu_register32(CPU_COM2TIMEOUT,250000);
		read_com2_bytes(&address,4);
		read_com2_bytes(&counter,4);
		push_variable(read_cpu_register32(CPU_CHECKSUM));
		read_com2_bytes(&checksum,4);
	}
	while(checksum!=pop_variable());
/*
	print_string("Loading ");
	print_number(counter);
	print_string(" bytes");
	new_line();
	print_string("at ");
	print_number(address);
	new_line();
*/
	if(address!=buffer)
	{
		return(0);
	}
	restart_checksum();
	read_com2_bytes(buffer,counter);
	push_variable(read_cpu_register32(CPU_CHECKSUM));
	read_com2_bytes(&checksum,4);
	if(checksum!=pop_variable())
	{
/*
		print_string("Bad Checksum");
		new_line();
*/
		return(0);
	}
	return(1);
}





