#define XBIM_CRYSTAL			64
#define XBIM_POWER_OFF		66
#define XBIM_POWER_TRANSMIT	68
#define XBIM_POWER_RECEIVE	70
#define XBIM_FREQUENCY		72
#define XBIM_AFC				74
#define XBIM_DEVIATION			76
#define XBIM_BANDWIDTH		78
#define XBIM_FILTER			80
#define XBIM_BAUDRATE			82

int	xbim_frequency_correction;
int	nordic_band;
int	radio_868_channel[8]={6,0,4,2,1,5,11,11};
int	radio_915_channel[8]={105,106,107,108,109,110,111,112};
int	radio_config[8];

public char radio_header_buffer[85];
public char *radio_header;
public int radio_header_size;
public set_radio_khz(int value)
{
	if(value<=40000)
	{
		if(value<=20000)
		{
			set_header(48);
			configure_xbim(XBIM_BAUDRATE,16);
			configure_xbim(XBIM_BANDWIDTH,160);
		}
		else
		{
			set_header(48);
			configure_xbim(XBIM_BAUDRATE,8);
			configure_xbim(XBIM_BANDWIDTH,32);
		}
	}
	else
	{
		set_header(32);
		configure_xbim(XBIM_BAUDRATE,2);
		configure_xbim(XBIM_BANDWIDTH,64);
		
	}
	set_radio_port_khz(value);
}

init_radio()
{
	int aux;

#IF forced_nordic_band 0 ;
	nordic_band=read_cpu_register32(35)&3;
#ENDIF ;

#IF forced_nordic_band 868 ;
	nordic_band=1;
#ENDIF ;

#IF forced_nordic_band 915 ;
	nordic_band=2;
#ENDIF ;

	if(read_cpu_register(0)&8)
	{
		for(aux=0;aux<8;aux++)
		{
			if(nordic_band&1)
			{
				radio_config[aux]=3072+radio_868_channel[aux]*4+nordic_band;
			}
			else
			{
				radio_config[aux]=3072+radio_915_channel[aux]*4+nordic_band;
			}
		}
	}
	else
	{
		for(aux=0;aux<8;aux++)
		{
			radio_config[aux]=42248+80*aux;
		}
		if(value_func_set_radio_khz==40000)
		{
			radio_config[0]=42521;			// 42528 433.92 Mhz	 
		}
	}

	memset(radio_header_buffer,84,82);
	radio_header_buffer[82]=0;
	radio_header_buffer[83]=0;
	radio_header_buffer[84]=255;
	set_header(32);

}




set_radio_channel(char *id)						//	3072+channel*4+1
{
	if(read_cpu_register(0)&8)
	{
		if(value_func_pic_version>=790)
		{
			write_cpu_register32(35,radio_config[((id[3]-'0')&7)]);
		}
	}
	else
	{
#IF new_xbim 1 ;
		configure_xbim(XBIM_FREQUENCY,(radio_config[((id[3]-'0')&7)])&255);
		configure_xbim(XBIM_FREQUENCY+1,(radio_config[((id[3]-'0')&7)])/256);
#ENDIF ;
	}
// "BAS01"
// "0 1234"
}

#IF software_type xrt100c ;
	char funcao;
	int licenca_base;
	int key;
	int mesa[2];
	int mesah[2];
	int lugar[2];

xbim_manual_frequency()
{
	int k,adjustment;
	adjustment=25+xbim_frequency_correction;
	k=0;
	set_display(0);
	cls();
	print_string("Frequency adjustment");
	new_line();
	do
	{
		display_xbim_frequency(adjustment,k);
		radio_channel_off
		xbim_frequency_correction=adjustment-25;
		set_radio_channel(work_base_id);
		radio_channel_send
		k=getch();
	}
	while(k!=27);
	radio_channel_off
}

testa_antena()
{
	funcao='F';
	send_to_pc(0,0);
	if(wait_conf())
	{
		beep(10,100);
		radio_channel_off
		return(1);
	}
	else
	{
		beep(2,500);
		radio_channel_off
		return(0);
	}
}

xbim_auto_frequency()
{
	int t,adjustment,middle,minimum;
	set_display(0);
	cls();
	print_string("Minimum frequency");
	new_line();
	adjustment=25;
	do
	{
		display_xbim_frequency(adjustment,0);
		xbim_frequency_correction=adjustment-25;
		set_radio_channel(work_base_id);

		t=testa_antena();
		if(t)
		{
			break;
		}
		adjustment--;
	}
	while(adjustment>=15);
	if(!t)
	{
		adjustment=25;
		do
		{
			display_xbim_frequency(adjustment,0);
			xbim_frequency_correction=adjustment-25;
			set_radio_channel(work_base_id);
	
			t=testa_antena();
			if(t)
			{
				break;
			}
			adjustment++;
		}
		while(adjustment<=35);
	}
	if(!t)
	{
		return(0);
	}
	middle=adjustment;
	do
	{
		display_xbim_frequency(adjustment,0);
		xbim_frequency_correction=adjustment-25;
		set_radio_channel(work_base_id);

		if(!testa_antena())
		{
			if(!testa_antena())
			{
				if(!testa_antena())
				{
					break;
				}
			}
		}

		adjustment--;
	}
	while(adjustment>0);
	minimum=adjustment;
	cursor_line(3);
	print_string("Maximum frequency");
	new_line();
	adjustment=middle;
	do
	{
		display_xbim_frequency(adjustment,0);
		xbim_frequency_correction=adjustment-25;
		set_radio_channel(work_base_id);

		if(!testa_antena())
		{
			if(!testa_antena())
			{
				if(!testa_antena())
				{
					break;
				}
			}
		}

		adjustment++;
	}
	while(adjustment<50);
	cursor_line(7);
	middle=(minimum+adjustment)/2;
	print_string("Central adjust=");
	print_number(((middle-25)*5)/2);
	print_string("KHz ");
	xbim_frequency_correction=middle-25;
	set_radio_channel(work_base_id);
	getch();
}

display_xbim_frequency(int adjustment,int k)
{
	tab(0);
	bar2(&adjustment,50,25,k);
	new_line();
/*
	k=cursor_func_bar2-1;
	if(k>19)
	{
		k=19;
	}
	tab(k);
*/
	tab(19);
	putch(' ');
	if(adjustment>25)
	{
		putch('+');
	}
	print_number(((adjustment-25)*5)/2);
	print_string("KHz  ");
	cursor(get_cursor()-display_width);
}

xbim_communication_test()
{
	int address,value;
	do
	{
		set_display(0);
		cls();
		print_string("Address: ");
		new_numerical(&address,3,0);
		new_line();
		print_string("Value: ");
		new_numerical(&value,3,0);
		if(address==999)
		{
			break;
		}
		configure_xbim(address,value);
	}
	while(1);
}

#ENDIF;
#IF system_type vertical horizontal ;
#IF wireless_network 1 ;

public set_gsm_khz(int value)
{
	write_cpu_register(4015,(20000000/64/value));
}

public set_radio_port_khz(int value)
{
	if(value_func_pic_version<760)
	{
		write_cpu_register(CPU_SPBRG,(20000000/64/value));
	}
	else
	{
		if(!(read_cpu_register(0)&8))
		{
			write_cpu_register(4015,(20000000/64/value));
		}
	}
}



set_header(int header_size)
{
	radio_header=radio_header_buffer+(85-header_size);
	radio_header_size=header_size+512;
}


public change_radio_khz()
{
	if(value_func_set_radio_khz==20000)
	{
		set_radio_khz(40000);
	}
	else
	{
		set_radio_khz(20000);
	}
}

#ENDIF ;
#ENDIF ;

//#define	radio_channel_receive		write_cpu_register(CPU_LHH_VALUE,59136+16); write_cpu_register(CPU_RCSTA,32512+128);
//#define	radio_channel_send			write_cpu_register(CPU_LHH_VALUE,59136+8); write_cpu_register(CPU_RCSTA,32512+128);
//#define	radio_channel_off			write_cpu_register(CPU_LHH_VALUE,59136+24); write_cpu_register(CPU_RCSTA,256*127);

configure_xbim(int address,int value)
{
	char buffer[3];
	if(value_func_pic_version>=750)
	{
		set_radio_port_khz(40000);
	
		write_cpu_register(3979,256*255+64);					// TXD bit up
		write_cpu_register(3988,256*(255-64));					// TXD bit as output
		write_cpu_register(CPU_LHH_VALUE,59136);
	
		buffer[0]=address;
		buffer[1]=((address*2)&255)+((address&128)/128)+value;
		buffer[2]=value;
	
		write_radio_block(buffer,3+512);
		delay(12000000/value_func_set_radio_port_khz);
	
		write_cpu_register(CPU_LHH_VALUE,59136+8+16);
		write_cpu_register(3979,256*(255-64));					// TXD bit down
		write_cpu_register(3988,256*(255-64));					// TXD bit as output
		write_cpu_register(3988,256*255+64);					// TXD bit as input
	
		if(value_func_set_radio_khz)
		{
			set_radio_port_khz(value_func_set_radio_khz);
		}	
	}
}

multibase_communication_test()
{
#IFNOT software_type RADIOBASE ;
#IF compile_radio_message 1 ;
	int x,y,y1,y2;
	char base[10];

	screen_format=15;
	set_display(0);

	cls();
	print_string("y1=");	
	new_numerical(&y1,1,0);
	new_line();
	print_string("y2=");	
	new_numerical(&y2,1,0);

	cls();
	cursor_width(0);
	strcpy(base,work_base_id);
	strcpy(base+6," R");

	do
	{
		for(y=y1;y<=y2;y++)
		{
			for(x=0;x<4;x++)
			{
				base[3]=y+'0';
				base[4]=x+'0';
				cursor(1+y+y+x*display_width);
				if(test_radio_base(base,3,-1))
				{
					putch('O');
					beep(5,100);
				}
				else
				{
					putch('-');
					beep(1,500);
				}
	//cursor(0);
	//print_string(base);
	//beep(5,100000);
			}
		}
	}
	while(1);
#ENDIF ;
#ENDIF ;
}

